package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.ArContent;
import com.izouma.awesomeadmin.service.ArContentService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/arContent")
public class ArContentController {

    @Autowired
    private ArContentService arContentService;

    /**
    * <p>获取全部记录。</p>
    */
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(ArContent record) {
        List<ArContent> pp = arContentService.getArContentList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getArContent", method = RequestMethod.GET)
    @ResponseBody
    public Result getArContent(@RequestParam(required = false, value = "id") String id) {
        ArContent data = arContentService.getArContentById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(ArContent record) {
        ArContent data = arContentService.getArContent(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, ArContent record) {
        Map<String, Object> result = new HashMap<>();

        List<ArContent> pp =arContentService.getArContentByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(ArContent record) {






        boolean num = arContentService.createArContent(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateArContent(ArContent record) {
        boolean num = arContentService.updateArContent(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteArContent(ArContent record) {

        boolean num = arContentService.deleteArContent(record);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, ArContent record) throws Exception {

    List<ArContent> arContents = arContentService.getArContentList(record);


        String sheetName = "ar_content";
        String titleName = "AR内容数据表";
        String fileName = "AR内容表";
        int columnNumber = 23;
        int[] columnWidth = { 20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20 };
        String[] columnName = {  "ID" ,   "删除标识" ,   "更新时间" ,   "更新人" ,   "创建时间" ,   "创建人" ,   "内容组ID" ,   "名称/描述" ,   "类别" ,   "文字" ,   "图片" ,   "URL" ,   "音频" ,   "视频" ,   "模型" ,   "文本文件" ,   "资源大小（M）" ,   "备注1" ,   "备注2" ,   "备注3" ,   "备注4" ,   "备注5" ,   "备注6"  };
        String[][] dataList = new String[arContents.size()][23];

        for (int i = 0; i < arContents.size(); i++) {

                        dataList[i][0] = String.valueOf(arContents.get(i).getId());
                        dataList[i][1] = String.valueOf(arContents.get(i).getDelFlag());
                        dataList[i][2] = String.valueOf(arContents.get(i).getUpdateTime());
                        dataList[i][3] = String.valueOf(arContents.get(i).getUpdateUser());
                        dataList[i][4] = String.valueOf(arContents.get(i).getCreateTime());
                        dataList[i][5] = String.valueOf(arContents.get(i).getCreateUser());
                        dataList[i][6] = String.valueOf(arContents.get(i).getGroupId());
                        dataList[i][7] = String.valueOf(arContents.get(i).getName());
                        dataList[i][8] = String.valueOf(arContents.get(i).getType());
                        dataList[i][9] = String.valueOf(arContents.get(i).getText());
                        dataList[i][10] = String.valueOf(arContents.get(i).getImage());
                        dataList[i][11] = String.valueOf(arContents.get(i).getUrl());
                        dataList[i][12] = String.valueOf(arContents.get(i).getVoice());
                        dataList[i][13] = String.valueOf(arContents.get(i).getMovie());
                        dataList[i][14] = String.valueOf(arContents.get(i).getModel());
                        dataList[i][15] = String.valueOf(arContents.get(i).getCfile());
                        dataList[i][16] = String.valueOf(arContents.get(i).getResourceSize());
                        dataList[i][17] = String.valueOf(arContents.get(i).getRemark1());
                        dataList[i][18] = String.valueOf(arContents.get(i).getRemark2());
                        dataList[i][19] = String.valueOf(arContents.get(i).getRemark3());
                        dataList[i][20] = String.valueOf(arContents.get(i).getRemark4());
                        dataList[i][21] = String.valueOf(arContents.get(i).getRemark5());
                        dataList[i][22] = String.valueOf(arContents.get(i).getRemark6());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

